package nl.kallestruik.ditems.script

import nl.kallestruik.ditems.DItems
import java.io.File
import kotlin.script.experimental.api.ScriptDiagnostic
import kotlin.script.experimental.host.toScriptSource
import kotlin.script.experimental.jvm.baseClassLoader
import kotlin.script.experimental.jvm.dependenciesFromCurrentContext
import kotlin.script.experimental.jvm.jvm
import kotlin.script.experimental.jvmhost.BasicJvmScriptingHost
import kotlin.script.experimental.jvmhost.createJvmCompilationConfigurationFromTemplate
import kotlin.script.experimental.jvmhost.createJvmEvaluationConfigurationFromTemplate

object DItemsScriptHost {

    fun evalFile(scriptFile: File): List<ScriptDiagnostic> {
        val compilationConfiguration = createJvmCompilationConfigurationFromTemplate<DItemsScript> {
            jvm {
                // Script will have access to everything in the classpath
                dependenciesFromCurrentContext(wholeClasspath = true)
            }
        }

        val evaluationConfiguration = createJvmEvaluationConfigurationFromTemplate<DItemsScript> {
            jvm {
                baseClassLoader.put(DItems::class.java.classLoader)
            }
        }

        val result = BasicJvmScriptingHost().eval(scriptFile.toScriptSource(), compilationConfiguration, evaluationConfiguration)
        return result.reports
    }
}